package paneles;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Font;

import javax.swing.BorderFactory;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.border.BevelBorder;
import javax.swing.table.DefaultTableCellRenderer;
import javax.swing.table.DefaultTableModel;
import javax.swing.table.JTableHeader;

@SuppressWarnings("serial")
public class PanelInforme extends JPanel{

	private MiTabla tabla;
	private JScrollPane sp;
	public JButton botonSalir;

	public PanelInforme(String[][] datos, int tipoInforme) {
		
		setLayout(new BorderLayout());
		
		crearTabla(datos, tipoInforme);
		
		JPanel norte = new JPanel();
		JLabel titulo;
		if (tipoInforme == 0)
			titulo = new JLabel("<html><p>Vehiculos en <u style=\"color: blue\">MANTENIMIENTO</u></p></html>");
		else
			titulo = new JLabel("<html><p>Vehiculos <u style=\"color: blue\">ENTREGADOS</u></p></html>");
		titulo.setFont(new Font("Verdana", Font.BOLD, 32));
		norte.add(titulo);
		norte.setBorder(BorderFactory.createCompoundBorder(
				BorderFactory.createEmptyBorder(20, 20, 10, 20),
				BorderFactory.createCompoundBorder(BorderFactory.createRaisedBevelBorder(), 
						BorderFactory.createEmptyBorder(10, 10, 10, 10))));
		
		JPanel centro = new JPanel();
		//Configuramos visor JSCrollPane con dimensiones y un borde
		sp = new JScrollPane(tabla);
		sp.setBorder(BorderFactory.createBevelBorder(BevelBorder.RAISED));
		sp.setPreferredSize(new Dimension(850, 150));
		//Al panel añadimos el JScrollPane que ya contiene nuestra tabla incrustada.
		centro.add(sp);
		centro.setBorder(BorderFactory.createCompoundBorder(BorderFactory.createEmptyBorder(10, 20, 10, 20),
				BorderFactory.createCompoundBorder(BorderFactory.createTitledBorder("Informe de Vehículos"),
						BorderFactory.createEmptyBorder(25, 20, 25, 20))));
		
		JPanel sur = new JPanel();
		botonSalir = new JButton("SALIR");
		botonSalir.setFont(new Font("Verdana", Font.BOLD, 22));
		sur.add(botonSalir);
		sur.setBorder(BorderFactory.createEmptyBorder(10, 20, 20, 10));
		
		add(norte, BorderLayout.NORTH);
		add(centro, BorderLayout.CENTER);
		add(sur, BorderLayout.SOUTH);
		
	}
	
	public void crearTabla(String[][] datos, int tipoInforme) {
		String[] cabecera;
		if (tipoInforme == 0) //Vehiculos en mantenimiento
			cabecera = new String[]{"Tipo Vehículo", "Placa", "VIN", "Marca", "Modelo", "Fec. Inicio"};
		else //Vehiculos entregados
			cabecera = new String[]{"Tipo Vehículo", "Placa", "VIN", "Marca", "Modelo", "Fec. Termino"};
		tabla = new MiTabla(datos, cabecera);
		tabla.setEnabled(false);
	}

	class MiTabla extends JTable {

		public MiTabla(String[][] datos, String[] nombresColumna) {
			//Incorporamos los datos y cabecera a la tabla
			super(new DefaultTableModel(datos, nombresColumna));
			//Pedimos al render que centre los textos en sus celdas.
			DefaultTableCellRenderer centerRenderer = new DefaultTableCellRenderer();
			centerRenderer.setHorizontalAlignment(SwingConstants.CENTER);
			setDefaultRenderer(Object.class, centerRenderer);
			//Cambiamos alguna fuente y color para los datos de la tabla
			setFont(new Font("Verdana", Font.PLAIN , 18));
			setForeground(Color.BLUE);
			//También cambiamos estilo de fuente a la cabecera
			JTableHeader cabecera = getTableHeader();
			cabecera.setFont(new Font("Verdana", Font.BOLD , 18));
		}
	}

}
