package paneles;

import java.awt.BorderLayout;
import java.awt.FlowLayout;
import java.awt.GridLayout;

import javax.swing.BorderFactory;
import javax.swing.BoxLayout;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JPasswordField;
import javax.swing.JTextField;

@SuppressWarnings("serial")
public class UsuarioLogin extends JPanel{
	
	public JTextField campoNombre;
	public JPasswordField campoPassword;
	public JButton botonIniciar;
	public JButton botonCrear;
	
	public UsuarioLogin() {
		campoNombre = new JTextField(10);
		campoPassword = new JPasswordField(10);
		botonIniciar = new JButton("Iniciar Sesion");
		botonCrear = new JButton("Crear Usuario");
		
		setLayout(new BorderLayout());
		add(new PanelCentro(), BorderLayout.CENTER);
		add(new PanelSur(), BorderLayout.SOUTH);
	}
	
	public void reset() {
		campoNombre.setText(null);
		campoPassword.setText(null);
	}
	
	private class PanelCentro extends JPanel {
		public PanelCentro() {
			setLayout(new BoxLayout(this, BoxLayout.Y_AXIS));
			add(new PanelEtiquetaYCampo("Nombre: ", campoNombre));
			add(new PanelEtiquetaYCampo("Password: ", campoPassword));
			setBorder(BorderFactory.createCompoundBorder(
					BorderFactory.createEmptyBorder(20, 20, 10, 20),
					BorderFactory.createCompoundBorder(
							BorderFactory.createTitledBorder("Iniciar Sesión"),
							BorderFactory.createEmptyBorder(10, 10, 10, 10))));
		}
	}
	
	private class PanelEtiquetaYCampo extends JPanel {
		public PanelEtiquetaYCampo(String txtEtiqueta, JTextField campo) {
			setLayout(new GridLayout(1, 2));
			JPanel panelEtiq = new JPanel();
			panelEtiq.setLayout(new FlowLayout(FlowLayout.RIGHT));
			panelEtiq.add(new JLabel(txtEtiqueta));
			JPanel panelCampo = new JPanel();
			panelCampo.setLayout(new FlowLayout(FlowLayout.LEFT));
			panelCampo.add(campo);
			add(panelEtiq);
			add(panelCampo);
		}
	}
	
	private class PanelSur extends JPanel {
		public PanelSur() {
			setLayout(new BoxLayout(this, BoxLayout.X_AXIS));
			JPanel panelIniciar = new JPanel();
			panelIniciar.add(botonIniciar);
			JPanel panelCrear = new JPanel();
			panelCrear.add(botonCrear);
			add(panelIniciar);
			add(panelCrear);
			setBorder(BorderFactory.createEmptyBorder(10, 20, 20, 20));
		}
	}

}

